"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Graphic_1 = require("./../Graphic");
var Tool_1 = require("./../Tool");
var Switch = (function (_super) {
    __extends(Switch, _super);
    /* LIFECYCLE */
    /**
     * @constructor
     */
    function Switch() {
        var _this = _super.call(this) || this;
        _this.setProps({
            label: "",
            activable: true
        });
        return _this;
    }
    /**
     * @initialize
     * @override
     */
    Switch.prototype.initialize = function (props) {
        var _this = this;
        _super.prototype.initialize.call(this, props);
        this.shape("shape", {
            width: 15,
            height: 15,
            stroke: this.context.theme.primaryColor,
            strokeThickness: 3,
            fill: Tool_1.Color.black,
            fillAlpha: 0.5
        }, {
            active: {
                fill: Tool_1.Color.cyan400,
                fillAlpha: 1
            }
        }).text("label", {
            x: 30,
            y: -2,
            text: this.props.label,
            fill: Tool_1.Color.white,
            fontSize: 15
        });
        this.connect(this.signals.propChange, "label", function () { return _this.text("label", { text: _this.props.label }); });
    };
    return Switch;
}(Graphic_1.Graphic));
exports.Switch = Switch;
