import { Graphic } from "./../Graphic";
import { Color, Enum } from "./../Tool";
import { ISwitchProps } from "./../Interface";


export class Switch extends Graphic {

    /* ATTRIBUTES */

    /**
     * Properties of a switch
     */
    props: ISwitchProps;


    /* LIFECYCLE */

    /**
     * @constructor
     */
    constructor () {
        super();

        this.setProps({
            label: "",
            activable: true
        });
    }

    /**
     * @initialize
     * @override
     */
    initialize (props) {
        super.initialize(props);

        this.shape("shape", {
            width: 15,
            height: 15,
            stroke: this.context.theme.primaryColor,
            strokeThickness: 3,
            fill: Color.black,
            fillAlpha: 0.5

        }, {
            active: {
                fill: Color.cyan400,
                fillAlpha: 1
            }

        }).text("label", {
            x: 30,
            y: -2,
            text: this.props.label,
            fill: Color.white,
            fontSize: 15
        });

        this.connect(this.signals.propChange, "label", () => this.text("label", { text: this.props.label }));
    }
}