import { Scene } from "./../Module";
import { Game } from "./../SideralObject";



/**
 * Interface for theme context
 */
export interface ITheme {

    /**
     * Primary color of the theme
     */
    primaryColor: string;

    /**
     * Secondary color
     */
    secondaryColor: string;

    /**
     * The theme of font family
     */
    fontFamily: string;

    /**
     * Custom properties for the theme
     */
    [key: string]: any;
}

/**
 * Interface for context
 */
export interface IContext {

    /**
     * The game linked to the current SideralObject
     */
    game?: Game;

    /**
     * The scene linked to the current SideralObject
     */
    scene?: Scene;

    /**
     * Theme to ensure that you use correct value for your graphics
     */
    theme?: ITheme;

    /**
     * Add your own context (useful for global data)
     */
    storage?: {[key: string]: any};
}